=== packaging/macosx/ports/python/py-gobject/Portfile ===
# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
# $Id$

PortSystem      1.0
PortGroup       python 1.0

name            py-gobject
set my_name     pygobject
version         2.28.6
revision        101
epoch           20110613
set branch      [join [lrange [split ${version} .] 0 1] .]
categories-append   gnome
license         LGPL-2.1+
maintainers     jwa openmaintainer
platforms       darwin
python.versions	26 27 33 34

description     Python bindings for GObject.

long_description \
    PyGObject provides a convenient wrapper for the GObject+ library \
    for use in Python programs, and takes care of many of the boring details \
    such as managing memory and type casting. \
    When combined with PyGTK, PyORBit and gnome-python, \
    it can be used to write full featured Gnome applications.

homepage        http://www.pygtk.org/
master_sites    gnome:sources/${my_name}/${branch}/
distname        ${my_name}-${version}
use_xz			yes

checksums       rmd160  4bc5e8546a5029d3d6b154629ab3fa4023d96bef \
                sha256  fb8a1d4f665130a125011659bd347c7339c944232163dbb9a34fd0686577adb8

if {$subport ne $name} {
    depends_build-append   port:pkgconfig
    depends_lib-append     path:lib/pkgconfig/glib-2.0.pc:glib2 \
                port:libffi \
                port:py${python.version}-cairo \
    			port:gobject-introspection

    patch.pre_args  -p1
    patchfiles  patch-pygi-info.c-p1.diff \
                00git_class_init.patch \
                00git_fix_qdata_warning.patch \
                00git_gio_flag_type.patch

    use_configure			yes
    configure.python        ${python.bin}
    configure.env-append    PKG_CONFIG_PATH='${python.prefix}/lib/pkgconfig'
    configure.pre_args      --prefix='${python.prefix}'
    configure.args-append	--disable-glibtest \
                            --enable-introspection=no
    configure.cppflags-append \
                            -I${python.prefix}/include \
        -I${prefix}/include/cairo
    build.cmd		[portbuild::build_getmaketype]
    build.target	

    destroot.cmd            ${build.cmd}
    destroot.target         install
    destroot.destdir        DESTDIR=${destroot}

    test.run        yes
    test.env        PYTHONPATH=[glob -nocomplain ${worksrcpath}/build/lib*]
    test.target     check

    post-destroot {
        set docdir ${prefix}/share/doc/${subport}
        xinstall -d ${destroot}${docdir}
        xinstall -m 0644 -W ${worksrcpath} AUTHORS COPYING ChangeLog NEWS README \
            ${destroot}${docdir}
    }
}

livecheck.type  none
